"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getKrakenLastSuccessfullyClosedOrder = exports.getKrakenClosedOrders = void 0;
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var private_api_request_1 = require("../api_clients/private_api_request");
exports.getKrakenClosedOrders = function (params) { return __awaiter(void 0, void 0, void 0, function () {
    var closed, closedOrdersIds;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'ClosedOrders', data: __assign({}, params ? params : {}) })];
            case 1:
                closed = (_a.sent()).closed;
                closedOrdersIds = Object.keys(closed);
                return [2 /*return*/, closedOrdersIds.map(function (orderid) { return (__assign({ orderid: orderid }, closed[orderid])); })];
        }
    });
}); };
exports.getKrakenLastSuccessfullyClosedOrder = function (params) { return __awaiter(void 0, void 0, void 0, function () {
    var closed, closedOrdersIds, successfullyClosedOrders, lastSuccessfullyClosedOrder, _a, lastOffset;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0: return [4 /*yield*/, private_api_request_1.krakenPrivateApiRequest({ url: 'ClosedOrders', data: __assign({}, params ? params : {}) })];
            case 1:
                closed = (_b.sent()).closed;
                closedOrdersIds = Object.keys(closed);
                if (closedOrdersIds.length === 0) {
                    return [2 /*return*/, null];
                }
                successfullyClosedOrders = closedOrdersIds.map(function (orderid) { return (__assign({ orderid: orderid }, closed[orderid])); }).filter(function (_a) {
                    var status = _a.status;
                    return status === 'closed';
                });
                lastSuccessfullyClosedOrder = successfullyClosedOrders.find(function (_a) {
                    var status = _a.status;
                    return status === 'closed';
                });
                if (!lastSuccessfullyClosedOrder) return [3 /*break*/, 2];
                return [2 /*return*/, lastSuccessfullyClosedOrder];
            case 2: 
            // Delay exec. 1.5 seconds to avoid rate limits
            return [4 /*yield*/, rxjs_1.timer(1500).pipe(operators_1.take(1)).toPromise()];
            case 3:
                // Delay exec. 1.5 seconds to avoid rate limits
                _b.sent();
                _a = params.ofs, lastOffset = _a === void 0 ? 0 : _a;
                return [2 /*return*/, exports.getKrakenLastSuccessfullyClosedOrder(__assign(__assign({}, params), { ofs: closedOrdersIds.length + lastOffset }))];
        }
    });
}); };
